#ifndef _indexing_h_
#define _indexing_h_
#include <iostream>
#include "graph.h"
#include "indexingNode.h"
struct arguments;
/*
struct arguments;

class iPartitionEntryType;
class IndexingNode;
class Indexing;
class iPartitionEntryType
{
	public:
	iPartitionEntryType(){};
	iPartitionEntryType(char c,IndexingNode* IN,std::string str)
	{
		direction=c;
		nodePtr=IN;
		label=str;
	};
	
	bool operator<(const iPartitionEntryType &r)const
	{
	int returnVal=0;
	if(this->direction!=r.direction)
	{
		if(this->direction<r.direction){return 1;}
		else {return 0;}
	}
	returnVal=this->label.compare(r.label);
	if(returnVal>0)
	{
		return returnVal;
	}
	return (this->nodePtr<r.nodePtr);
	};
	char direction;
	IndexingNode* nodePtr;
	std::string label;
};
#define nodeListType std::vector<MyNode*>

class IndexingValue
{
friend class Searcher;
public:
	//Creators
	IndexingValue(){method='0';};
	IndexingValue(char m){method=m;};
	//Modifiers
	void setMethod(char m,char m2){method=m;method2=m2;};
	void addIPartition(char d,IndexingNode* p, std::string l,unsigned int n);
	void setType(unsigned int t){type=t;};
	//Accessors
	char getMethod()const{return method;};
	char getMethod2()const{return method2;};
	std::map<iPartitionEntryType,unsigned int>::const_iterator getFirstEntry()const{return iPartitionIndexValue.begin();};
	std::map<iPartitionEntryType,unsigned int>::const_iterator getEndEntry()const{return iPartitionIndexValue.end();};
	
	//iPartitionEntryType getEntry(unsigned int i)const{return iPartitionIndexValue[i];};
	unsigned int getSize()const;
	unsigned int getType()const{return type;};
	
	//functions
	int compare(const IndexingValue& v2)const;
	void clear();
	void sortMe();
private:
	//iPartitionEntryType getIPartitionIndexValue(unsigned int i)const;
	char method,method2;
	std::map<iPartitionEntryType,unsigned int > iPartitionIndexValue;
	unsigned int type;
};

class IndexingNode
{
public:
	//Constructors
	IndexingNode(){};
	IndexingNode(Indexing* iPtr, std::vector<MyNode*>& n,unsigned int i){IndexingPtr=iPtr; nodes=n;setID(i);};
	//accessors
	const std::vector<MyNode*>* getNodes() const{return &nodes;};
	const std::list<IndexingNode* >* getSubpartitions()const {return &subpartitions;};
	unsigned int getId() const{return id;};
	const IndexingValue* getIndexValue()const{return &indexValue;};
	unsigned int getNumNodes(){return nodes.size();};
	//modifiers
	void setNodes(std::vector<MyNode*>& n);
	void setID(unsigned int i){id=i;};
	void splitPartition(unsigned int &nextID,arguments& args);
	void updateIndex(char method,unsigned int i,char method2,arguments& args);
private:
	//Internal Use
	void sortPartition();
	void newSubpartition(unsigned int& currentNode,unsigned int& i,unsigned int& nextID);
	//Representation
	nodeListType nodes;
	unsigned int id;
	
	std::list<IndexingNode* > subpartitions;
	IndexingValue indexValue;
	Indexing* IndexingPtr;
};

class Indexing
{
friend class Searcher;
public:
	//Constructors
	Indexing();
	Indexing(std::vector<MyNode*>& n, char m,char m2,unsigned int maxLevel, arguments& args);
	//Modifiers
	void partition();
	void init(std::vector<MyNode*>& n, char m, char m2, unsigned int maxLevel,arguments& args);
	void setMethod(char m,char m2){method=m;method2=m2;};
	IndexingNode* addNode(std::vector<MyNode*>& n,unsigned int& i){allSubpartitions.push_back(IndexingNode(this,n,i));
	return &allSubpartitions.back();};
	//Accessors
	IndexingNode* getRoot(){return &root;};
	char getMethod()const{return method;};
	char getMethod2()const{return method2;};
private:
	IndexingNode root;
	std::list< IndexingNode > allSubpartitions;
	unsigned int nextID;
	char method,method2;
};
*/
class Indexing
{
public:
	Indexing(){};
	void init(std::vector<MyNode*>& nodeSorted,arguments& args);
	void updateIndex(unsigned int i);
	void partition(unsigned int i);
	IndexingNode* newPartition(unsigned int level,std::list<MyNode*>::const_iterator begin, std::list<MyNode*>::const_iterator end,IndexingNode* parent);
	IndexingNode* getRoot();
private:
	arguments* args;
	IndexingNode* root;
	std::vector<std::list<IndexingNode> > partitionLevels;
	unsigned int nextID;
	
};
#endif