#ifndef _indexingnode_h_
#define _indexingnode_h_
#include <iostream>
#include "graph.h"
#include "indexingValue.h"
class IndexingValue;
class Indexing;
class IndexingNode
{
	friend class Indexing;
	public:
		//constructors
		IndexingNode(){mark=false;};
		IndexingNode(unsigned int l,std::list<MyNode*>::const_iterator begin, std::list<MyNode*>::const_iterator end,IndexingNode* parentPtr);
		IndexingNode(unsigned int l,std::vector<MyNode*> n,IndexingNode* parentPtr);
		//modifiers
		void intersect(std::list<MyNode*>& iList);
		void addNodes(std::list<MyNode*>::const_iterator begin, std::list<MyNode*>::const_iterator end);
		void addNodes(std::vector<MyNode*> n);
		void partitionByType(Indexing* index);
		void partitionByIDegree(unsigned int i,Indexing* index);
		void createSubpartition(std::list<MyNode*>::const_iterator l,std::list<MyNode*>::const_iterator r,Indexing* index);
		void updatePtrs();
		
		//accessors
		std::list<IndexingNode*>* getSubpartitions();
		IndexingValue* getIndexValue();
		unsigned int getNumNodes()const{return nodes.size();};
		std::list<MyNode*>::const_iterator getNodesBegin(){return nodes.begin();};
		std::list<MyNode*>::const_iterator getNodesEnd(){return nodes.end();};
		unsigned int getLevel()const {return level;};
		public:std::list<MyNode*> nodes;
		std::list<IndexingNode*> subpartitions;
		unsigned int mark;
		IndexingNode* parent;
	private:
		IndexingValue value;
		unsigned int level;
};


#endif