#ifndef _GRAPH_H_
#define _GRAPH_H_

#include <list>
#include <limits.h>
#include <float.h>
#include <map>
#include <string>
#include <stdio.h>
#include <errno.h>
#include <vector>
#include <math.h>

#include <boost/config.hpp>
#include <boost/utility.hpp>             // for boost::tie
#include <boost/graph/graph_traits.hpp>  // for boost::graph_traits
#include <boost/graph/adjacency_list.hpp>

#define LABEL_LEN 8

class MyNode
{
public:
	MyNode();
	unsigned int id;
	unsigned short type;
	unsigned char llen;
	char* label;
	unsigned long index;
	boost::adjacency_list<boost::vecS, boost::vecS, boost::bidirectionalS>* adj;
	std::vector<unsigned int> outgoing_edges;	//outgoing edges: end points are identified by the node ID
	std::vector<unsigned int> incoming_edges;	//added July 7
	std::vector<float> iDegree[3];			//position[i-1] will be the i-degree of that node  <double> is used to allow for % of neighbors of a type rather than count
	std::vector<float> iniDegree[3];			//position[i-1] will be the i-degree of that node  <double> is used to allow for % of neighbors of a type rather than count
	bool indexed;	
};

#endif
