#include <iostream>
#include <fstream>
#include "graph.h"
#include <algorithm>
#include "utilities.h"

MyPartitioning::MyPartitioning()
{
	allSubPartitions.reserve(000000);//This needs to be large, to encompass all the partitions made
	//If the program crashes for an unknown reason, it's probably because of a falty pointer because this number was too small.
	//TODO: Correct pointers when vector reallocates memory. (or maybe don't use pointers)
	
	allSubPartitions.push_back(MyPartition());
	rootPtr=&allSubPartitions[0];
	rootPtr->setNum(0);
	rootPtr->setParent((unsigned long long int)-1);
	clearNodes();
}
void MyPartitioning::clearNodes()
{
	nodeHeirarchy.empty();
}
void MyPartitioning::beginPartitioning(char meth)
{
	//o = outonly
	//i = inonly
	//s = out and in
	//b = bidirectional
	method=meth;
	method='b';
	
	std::vector<MyNode*>::iterator itr=rootPtr->nodes.begin();
	leaves.push_back(rootPtr->getNum());
	for(;itr!=rootPtr->nodes.end();itr++)//seed the partition
	{
		(*itr)->partitionString=my_itoa((*itr)->getType());
		(*itr)->neighborChanged=true;
	}
	rechecker[rootPtr->getNum()]=true;
	fprintf(stderr, "bp\n");
	iterate(10);
	fprintf(stderr, "done...\n");

	expandLeaves();
	printPartitions();
}
void MyPartitioning::expandLeaves()
{
	return;
	sortLeaves();
	for(std::vector<unsigned long long int>::iterator leaf=leaves.begin();leaf!=leaves.end();leaf++)
	{
		if(getPartition(*leaf)->nodes.size()>1)
		{
			for(std::vector<MyNode*>::iterator node=getPartition(*leaf)->nodes.begin();node!=getPartition(*leaf)->nodes.end();node++)
			{
				//this partition has ended. create subpartition
				allSubPartitions.push_back(MyPartition());
				MyPartition* newPart=&allSubPartitions.back();
				newPart->setNum(allSubPartitions.size()-1);
				newPart->nodes.push_back((*node));
				getPartition(*leaf)->subpartitions.push_back(newPart->getNum());
				nodeHeirarchy[(*node)->getID()].push_back(newPart->getNum());
				(*node)->lastPartition=newPart->getNum();
				nextLeaves.push_back(newPart->getNum());
			}
		}
		else
		{
			nextLeaves.push_back(*leaf);
		}
	}
	leaves=nextLeaves;
	nextLeaves=std::vector<unsigned long long int>();
	resort();
	restring();
}
void MyPartitioning::uniqueRepartitioning(bagsType& bags,MyNode* node,MyNode* node2)
{
	/*method='b';
	allSubPartitions.push_back(MyPartition());
	MyPartition* newRootPart=&allSubPartitions.back();
	for(std::vector<MyNode*>::iterator node=rootPtr->nodes.begin();node!=rootPtr->nodes.end(); node++)
	{
		(*node)->partitioning.clear();
		(*node)->partitioning.push_back(newRootPart->num);
		(*node)->partitionString=my_itoa((*node)->getType());
		(*node)->neighborChanged=true;
	}
	nextchecker.clear();
	rechecker.clear();
	nextchecker[newRootPart]=true;
	newRootPart->num=nextNum;
	newRootPart->nodes.insert(newRootPart->nodes.begin(),rootPtr->nodes.begin(),rootPtr->nodes.end());
	nextNum++;
	rootPtr->subpartitions.push_back(newRootPart->num);
	std::vector<MyNode*>::iterator nodes;
	nextLeaves.push_back(newRootPart->num);
	
	for(bagsType::iterator 
		itr = bags->begin();itr!=bags->end();itr++)
	{
		if((*itr).second.size()==1 && getPartition((*itr).second.begin()->first)->nodes.size()==1)
		{
			MyNode* node=getPartition((*itr).second.begin()->first)->nodes[0];
			node->partitioning.clear();
			for(std::vector<MyNode*>::iterator i=newRootPart->nodes.begin();
				i!=newRootPart->nodes.end();i++)
			{
				if((*i)==node)
				{
					newRootPart->nodes.erase(i);
					break;
				}
			}
			allSubPartitions.push_back(MyPartition());
			MyPartition* newPart=&allSubPartitions.back();
			nextchecker[newPart]=true;
			newPart->num=nextNum;
			newPart->nodes.push_back(node);
			rootPtr->subpartitions.push_back(newPart->num);
			std::vector<MyNode*>::iterator nodes;
			node->partitioning.push_back(newPart->num);
			nextNum++;
			nextLeaves.push_back(newPart->num);
			fprintf(stdout,"singleton\n");
		}
	}
	leaves=nextLeaves;
	rechecker=nextchecker;
	nextchecker=std::map<MyPartition*,bool>();
	nextLeaves=std::vector<unsigned long long int>();
	iterate(10);*/
	fprintf(stderr,"Repartitioning\n");
	bool halt=false;
	unsigned long long int partitionID=0;
	for(std::vector<unsigned long long int>::iterator leaf=leaves.begin();!halt && leaf!=leaves.end();leaf++)
	{
		for(std::vector<MyNode*>::iterator j=getPartition(*leaf)->nodes.begin();!halt && j!=getPartition(*leaf)->nodes.end();j++)
		{
			if((*j)==node2)
			{
				//fprintf(stdout,"Found j\n");
				partitionID=getPartition(*leaf)->getNum();
				if(getPartition(*leaf)->nodes.size()!=1)
				{
					fprintf(stdout," not single\n");
					//this partition has ended. create subpartition
					allSubPartitions.push_back(MyPartition());
					MyPartition* newPart=&allSubPartitions.back();
					newPart->setNum(allSubPartitions.size()-1);
					nextchecker[newPart->getNum()]=true;
					newPart->nodes.insert(newPart->nodes.begin(),getPartition(*leaf)->nodes.begin(),getPartition(*leaf)->nodes.end());
					getPartition(*leaf)->subpartitions.push_back(newPart->getNum());
					
					std::vector<MyNode*>::iterator nodes;
					for(nodes=newPart->nodes.begin();nodes!=newPart->nodes.end();nodes++)
					{
						if((*nodes)==node2)
						{
							//this partition has ended. create subpartition
							allSubPartitions.push_back(MyPartition());
							MyPartition* newPart=&allSubPartitions.back();
							newPart->setNum(allSubPartitions.size());
							nextchecker[newPart->getNum()]=true;
							newPart->nodes.push_back(node2);
							getPartition(*leaf)->subpartitions.push_back(newPart->getNum());
							(*nodes)->lastPartition=newPart->getNum();
							newPart->nodes.erase(nodes);
							break;
						}
					}
					for(nodes=newPart->nodes.begin();nodes!=newPart->nodes.end();nodes++)
					{
						nodeHeirarchy[(*nodes)->getID()].push_back(newPart->getNum());
						(*nodes)->lastPartition=newPart->getNum();
					}
					nextLeaves.push_back(newPart->getNum());
				}
				halt=true;
				break;
			}
		}
	}
	for(bagsType::iterator b=bags.begin();b!=bags.end();b++)
	{
		if(b->first==node->getID())
		{
			//fprintf(stdout,"This happens %d\n",node2->getID());
			b->second.clear();
			b->second[partitionID]=0;
			//make this node only mappable to this one node (within this one partition).
		}
		if(b->second.size()==1 && getPartition(b->second.begin()->first)->nodes.size()==1)
		{//if this node can only map to 1 partition
		//which contains only 1 node
			for(bagsType::iterator c=bags.begin();c!=bags.end();c++)
			{//for each bag
				if(b!=c)
				{//if they are not the same bag
					mappingType::iterator a=c->second.find(b->second.begin()->first);
					//where a== the location of the same partition
					if(a!=c->second.end())
					{//if that partition (containing 1 node) belongs to another bag
						c->second.erase(a);
						//remove that partition from that bag.
					}
				}
			}
		}
	}
}
void MyPartitioning::iterate(unsigned int iters)
{
	bool cont=true;
	unsigned long long int n=0;
	while(cont && iters>0)
	{
		iters--;
		fprintf(stderr,"%d ->\n",(unsigned)leaves.size());
		cont=false;
		//fprintf(stderr, "Sort Next\n");
		sortLeaves();
		//fprintf(stderr, "Repart Next\n");

		cont=repartition();
		//fprintf(stderr, "Resort Next\n");

		resort();
		//fprintf(stderr, "Restring Next\n");

		restring();
		n++;
		//fprintf(stderr, "Done with this Iter\n");

	}
	fprintf(stderr,"Done iters\n");
}
void MyPartitioning::sortLeaves()
{
	//sort the leaves by the partition string.
	std::vector<unsigned long long int>::iterator partitions;
	for(partitions=leaves.begin();partitions!=leaves.end();partitions++)
	{
		sort(getPartition(*partitions)->nodes.begin(),getPartition(*partitions)->nodes.end(),iterativePartitionSort);
	}
}
void MyPartitioning::resort()
{
	//sort the nodes in each partition, and their neighbors.
	std::vector<unsigned long long int>::iterator partitions;
	for(partitions=leaves.begin();partitions!=leaves.end();partitions++)
	{
		//for each partition in the leaves
		std::vector<MyNode*>::iterator nodes;
		for(nodes=getPartition(*partitions)->nodes.begin();nodes!=getPartition(*partitions)->nodes.end();nodes++)
		{
			(*nodes)->resortEdges();
		}
	}
}
bool MyPartitioning::repartition()
{
	//fprintf(stderr,"size %d\n",rechecker.size());
	bool found=false;
	//repartition the nodes
	std::vector<unsigned long long int>::iterator partitions;

	for(partitions=leaves.begin();partitions!=leaves.end();partitions++)
	{
		std::vector<MyNode*>::iterator start=getPartition(*partitions)->nodes.begin();
		if( rechecker.find(*partitions)!=rechecker.end() 
			&& iterativePartitionSortInt(*start, (getPartition(*partitions)->nodes.back()))!=0)
		{//for each leaf partition.
			std::vector<MyNode*>::iterator end;
			for(end=start; end!=getPartition(*partitions)->nodes.end();end++)
				//TODO: don't use a linear search
			{//if this node, and the next one, have different partition strings, then subpartition
				//fprintf(stderr,"%d / %d\n",end-start, getPartition(*partitions)->nodes.size());
				if((*end)->partitionString.compare((*start)->partitionString)!=0)
				{//this partition has ended. create subpartition
					createSubpartition(getPartition(*partitions),start,end);
					start=end;
				}
			}
			if(getPartition(*partitions)->subpartitions.size()!=0)
			{//there was a subpartition. Finish it.
				createSubpartition(getPartition(*partitions),start,getPartition(*partitions)->nodes.end());
				found=true;
			}
		}
		else
		{//there was no new partitionings.
			nextLeaves.push_back(*partitions);
		}
	}
	//fprintf(stderr, "--halfway done with Repart\n");

	leaves=nextLeaves;
	rechecker=nextchecker;
	for(std::map<unsigned long long int,bool>::iterator itr=rechecker.begin();itr!=rechecker.end();itr++)
	{
		edgelist edges=getPartition(itr->first)->nodes[0]->getUndirectedEdges();
		for(edgelist::iterator edgeitr=edges.begin(); edgeitr!=edges.end(); edgeitr++)
		{
			nextchecker[(*edgeitr).second.getNode()->lastPartition]=true;
		}
	}
	//fprintf(stderr, "--Mostly Done with Repart\n");

	rechecker=nextchecker;
	nextchecker=std::map<unsigned long long int,bool>();
	nextLeaves=std::vector<unsigned long long int>();
	return found;
}
void MyPartitioning::restring()
{
	if(method!='o' && method!='s' &&method!='i' &&method!='b')
	{
		fprintf(stderr,"No method specified\n");
	}
	std::vector<unsigned long long int>::iterator partitions;
	//fprintf(stderr,"restringing %d %d\n",leaves.size(),rechecker.size());
	for(partitions=leaves.begin();partitions!=leaves.end();partitions++)
	{	
		if(rechecker.find(*partitions)==rechecker.end())
		{
			continue;
		}
		std::vector<MyNode*>::iterator end=getPartition(*partitions)->nodes.begin();
		edgelist::const_iterator neighbor;
		for(; end!=getPartition(*partitions)->nodes.end();end++)
		{
			std::string s;
			s=my_itoa((*end)->lastPartition);//type
			//out edges
			if(method=='o' || method=='s')
			{
				fprintf(stderr,"depricated, 'o', 's'\n");
				exit(0);
				const edgelist* outedges=(*end)->getOutEdgesConst();
				for(neighbor=outedges->begin();neighbor!=outedges->end();neighbor++)
				{
					s+='<';
					s+=my_itoa((*neighbor).second.getNode()->lastPartition);
				}
			}
			if(method=='s' || method =='i')
			{
				fprintf(stderr,"depricated, 's','i'\n");
				exit(0);
				const edgelist* inedges=(*end)->getInEdgesConst();
				for(neighbor=inedges->begin();neighbor!=inedges->end();neighbor++)
				{
					s+='>';
					s+=my_itoa((*neighbor).second.getNode()->lastPartition);
				}
			}
			if(method=='b')
			{
				edgelist outedges=(*end)->getOutOnlyEdges();
				for(neighbor=outedges.begin();neighbor!=outedges.end();neighbor++)
				{
					s+='<';
					s+=neighbor->second.getEdgeLabel();
					s+=my_itoa((*neighbor).second.getNode()->lastPartition);
				}
				edgelist biedges;//=(*end)->getBidirectionalEdges();
				for(neighbor=biedges.begin();neighbor!=biedges.end();neighbor++)
				{
					s+='|';
					s+=neighbor->second.getEdgeLabel();
					s+=my_itoa((*neighbor).second.getNode()->lastPartition);
				}
				edgelist inedges=(*end)->getInOnlyEdges();
				for(neighbor=inedges.begin();neighbor!=inedges.end();neighbor++)
				{
					s+='>';
					s+=neighbor->second.getEdgeLabel();
					s+=my_itoa((*neighbor).second.getNode()->lastPartition);
				}
			}
			(*end)->partitionString=s;
		}
	}
}
void MyPartitioning::addNodes(std::vector<MyNode*>::const_iterator start,std::vector<MyNode*>::const_iterator end)
{
	rootPtr->nodes.insert(rootPtr->nodes.begin(),start,end);
}

MyPartition* MyPartitioning::getPartition(unsigned long long int x)
{
	return &(allSubPartitions[x]);
}
const MyPartition* MyPartitioning::getPartitionConst(unsigned long long int x) const
{
	return &(allSubPartitions[x]);
}
void MyPartitioning::printPartitions()
{
	//don't print partitions
	return;
	for(unsigned i=0;i<allSubPartitions.size();i++)
		fprintf(stdout,"%d %d\n",i,allSubPartitions[i].getNum());
	exit(0);
}

void MyPartitioning::createSubpartition(MyPartition* parent, std::vector<MyNode*>::iterator start, std::vector<MyNode*>::iterator end)
{
	if(parent==0)
	{
		fprintf(stderr,"Parent is a Null Pointer\n");
		exit(0);
	}
	//fprintf(stderr,"Create SubPartitions\n");
	allSubPartitions.push_back(MyPartition());
	//fprintf(stderr,"-Created SubPartitiong\n");
	MyPartition* newPart=&allSubPartitions.back();
	//fprintf(stderr,"-newPart = all subpart.back\n");

	newPart->setNum(allSubPartitions.size()-1);
	//fprintf(stderr,"-newpartNum %u\n",newPart->getNum());
//	fprintf(stderr,"-parent %u\n",parent);
	//fprintf(stderr,"-parentNum %u\n",parent->getNum());
	newPart->setParent(parent->getNum());
	//fprintf(stderr,"-Indexing NextChecker %d\n",nextchecker.size());
	nextchecker[newPart->getNum()]=true;
	//fprintf(stderr,"Create SubPartitions- Insert Nodes\n");
	newPart->nodes.insert(newPart->nodes.begin(),start,end);
	//fprintf(stderr,"Create SubPartitions- Pushback\n");
	parent->subpartitions.push_back(newPart->getNum());
	std::vector<MyNode*>::iterator nodes;
//	fprintf(stderr,"Create SubPartitions For Loop Start\n");
	for(nodes=start;nodes!=end;nodes++)
	{
		//fprintf(stderr,"--Loop Insides %d / %d\n",end-nodes, end-start);
		nodeHeirarchy[(*nodes)->getID()].push_back(newPart->getNum());
		(*nodes)->lastPartition=newPart->getNum();
	}
	nextLeaves.push_back(newPart->getNum());
//	fprintf(stderr,"Done Create SubPartitions\n");
}

