#ifndef _partitioning_h_
#define _partitioning_h_
#include <iostream>
#include "graph.h"
#include "indexing.h"


class MyPartition
{
public:
	std::vector<unsigned long long int> subpartitions;
	std::vector<MyNode*> nodes;
	unsigned long long int getNum(){/*fprintf(stderr,"+%d\n",num);*/return num;};
	void setNum(unsigned long long int p){num=p;};
	
	unsigned long long int getParent(){return parent;};
	void setParent(unsigned long long int p){parent=p;};
private:
	unsigned long long int num;
	unsigned long long int parent;
	//bool needsUpdate;//todo add if slow
};
class MyPartitioning
{
public:
	MyPartitioning();
	void addNodes(std::vector<MyNode*>::const_iterator start,std::vector<MyNode*>::const_iterator end);
	void beginPartitioning(char meth);
	void uniqueRepartitioning(bagsType& bags,MyNode* node,MyNode* node2);
	void iterate(unsigned int iters);
	
	MyPartition* rootPtr;
	void clearNodes();
	MyPartition* getPartition(unsigned long long int x);
	const MyPartition* getPartitionConst(unsigned long long int x) const;
	void printPartitions();
	std::map<unsigned int, std::vector<unsigned int> > nodeHeirarchy;
private:
	std::map<unsigned long long int, bool> rechecker,nextchecker;
	std::vector<unsigned long long int> leaves,nextLeaves;
	std::vector<MyPartition> allSubPartitions;
	bool repartition();
	void resort();
	void restring();
	void sortLeaves();
	void expandLeaves();
	void createSubpartition(MyPartition* parent, std::vector<MyNode*>::iterator start, std::vector<MyNode*>::iterator end);
	char method;
};
#endif