#ifndef _search_h_
#define _search_h_
#include <iostream>
#include "graph.h"
#include <vector>
#include <map>
#include <list>
#include <unordered_map>
#define MxOptions std::unordered_map<IndexingNode*,bool>
#define MxVector std::unordered_map<IndexingNode*, MxOptions >
#define CandidateList std::vector< std::pair<double, std::map<unsigned int, unsigned int> > > 
/*class PartitionDescriptor
{
public:
	PartitionDescriptor();
	PartitionDescriptor(Indexing& i,unsigned int h,unsigned int pNum);
private:
	unsigned int height;
	unsigned int partitionNum;
	Indexing* index;
};*/
/*class Searcher
{
public:
	Searcher();
	Searcher(Indexing& ind,MyGraph* f, arguments& args);
	void Search(Indexing& ind,MyGraph* f, arguments& args);
private:
	bool testMappable(IndexingNode* child, IndexingNode* jchild,unsigned int currentLevel);
	void initPossibilities();
	void refine(unsigned int h,unsigned int currentLevel=0);
	bool dominates(IndexingNode* v1, IndexingNode* v2,unsigned int level)const;
	//Representation
	std::vector< MxVector > possibilityHeirarchy;//map fragment indexing nodes to database indexing nodes
	Indexing* index;
	MyGraph* fragment;
};*/

class Searcher
{
public:
	Searcher();
	Searcher(Indexing& ind, MyGraph* f, arguments& args, MyGraph* d);
	void Search(Indexing& ind, MyGraph* f, arguments& args, MyGraph* d);
	//mapping
	CandidateList mapFragment(MyGraph* database,arguments& args);
	
	bool mxReduce(std::map<unsigned int, std::list<unsigned int> >& Mx,MyGraph* fragment, MyGraph* database,FILE* output);
private:
	//init
	void initPossibilities();
	//search
	void convertMX(std::map<unsigned int, std::list<unsigned int> >& Mx);
	void refine(unsigned int steps);
	void refineDFS(unsigned int steps,std::map<unsigned int, std::list<unsigned int> > &Mx);
	void refineInner(unsigned int currentStep);
	bool testMappable(IndexingNode* child, IndexingNode* jchild,unsigned int currentLevel);
	bool dominates(IndexingNode* v1, IndexingNode* v2,unsigned int level)const;
	bool toggleMark(std::list<IndexingNode*>* leafs, bool value, bool outNeighbors);
	std::list<IndexingNode*> toggleMark(std::list<unsigned int> leafs, unsigned int value, bool outNeighbors);
	//mx reduction
	unsigned int initReducedMx(MxVector mx);
	bool shrinkUntilStable(std::map<unsigned int, std::list<unsigned int> >& Mx,MyGraph* fragment, MyGraph* database,FILE* output);
	//bool reduceNeighborhood(MxVector mx);
	//utilities
	void printMx(FILE* output);
	float evaluatePartialMap(std::map<unsigned int, unsigned int>& M, MyGraph* frag, MyGraph* database,bool noError=false);
	float evaluateOneNode(std::map<unsigned int, unsigned int>& M, MyGraph* frag, MyGraph* database, MyNode* node,float bestScore,bool noError=false);
	//Representation
	std::list< MxVector > possibilityHeirarchy;
	Indexing* index;
	MyGraph* fragment;
	MyGraph* database;
	std::list<IndexingNode> reducedMx,reducedMxDB;
	arguments* args;
	
	
	std::map<unsigned int, std::list<unsigned int> > MxFinished;
};

#endif